Attribute VB_Name = "mdUtf8"
Option Explicit

Public Const WC_COMPOSITECHECK = &H200
Public Const WC_DEFAULTCHAR = &H40
Public Const WC_DISCARDNS = &H10
Public Const WC_SEPCHARS = &H20

Public Const CP_ACP = 0
Public Const CP_OEMCP = 1
Public Const CP_MACCP = 2
Public Const CP_THREAD_ACP = 3
Public Const CP_SYMBOL = 42
Public Const CP_UTF7 = 65000
Public Const CP_UTF8 = 65001

Public Const MB_PRECOMPOSED = &H1
Public Const MB_COMPOSITE = &H2
Public Const MB_USEGLYPHCHARS = &H4
Public Const MB_ERR_INVALID_CHARS = &H8


Public Declare Function RegisterClipboardFormat Lib "user32" Alias "RegisterClipboardFormatA" (ByVal lpString As String) As Long

'Private Declare Function LocalAlloc Lib "kernel32.dll" (ByVal wFlags As Long, ByVal wBytes As Long) As Long
'Private Declare Function LocalFree Lib "kernel32.dll" (ByVal hMem As Long) As Long
Private Declare Function MultiByteToWideChar Lib "kernel32.dll" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpMultiByteStr As String, ByVal cchMultiByte As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long) As Long
Private Declare Function WideCharToMultiByte Lib "kernel32.dll" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long, ByVal lpMultiByteStr As Long, ByVal cchMultiByte As Long, ByVal lpDefaultChar As Long, ByVal lpUsedDefaultChar As Long) As Long
'Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
'Private Const CP_UTF8       As Long = 65001
'Private Const LMEM_ZEROINIT As Long = &H40



Public Function UTF8ToWin(ByVal inString As String) As String
'http://forum.sources.ru/index.php?showtopic=230052&hl=
        Dim hMemLock1   As Long, hMemLock2  As Long
        Dim iStrSize    As Long, lMaxSize As Long, str1 As String, str2 As String
     '    ,    NULL-terminated
        inString = inString & vbNullChar '& vbNullChar
     '      :)    
        
        lMaxSize = Len(inString)
        str1 = String$(lMaxSize, 0&)
        str2 = String$(lMaxSize, 0&)
        hMemLock1 = StrPtr(str1)
        hMemLock2 = StrPtr(str2)
        
'        hMemLock1 = LocalAlloc(LMEM_ZEROINIT, lMaxSize)'      
'        hMemLock2 = LocalAlloc(LMEM_ZEROINIT, lMaxSize)


        iStrSize = MultiByteToWideChar(CP_UTF8, 0&, inString, &HFFFF, hMemLock1, lMaxSize)
        iStrSize = WideCharToMultiByte(0&, 0&, hMemLock1, &HFFFF, hMemLock2, iStrSize, 0&, 0&)

        If Len(iStrSize) Then
        UTF8ToWin = StrConv(str2, vbUnicode)
'            UTF8ToWin = String$(iStrSize, 0&)
'            Call CopyMemory(ByVal UTF8ToWin, ByVal hMemLock2, iStrSize)
        End If

'        Call LocalFree(hMemLock1)
'        Call LocalFree(hMemLock2)
End Function




'    !    
'http://soobcha-vb.narod.ru/projects/active/soobchiler/mdlcodepage.htm


''   
'
'WideCharToMultiByte ' Unicode    .
''      - .
''(  ...)
''
'CodePage ' ,   .
''       ,
''     .
''        :
'CP_ACP - ANSI code page
'CP_MACCP - Macintosh code page
'CP_OEMCP - OEM code page
'CP_SYMBOL - Symbol code page (42)
'CP_THREAD_ACP
'CP_UTF7
'CP_UTF8
'
'dwFlags ' ,   ,
''    . 
''         .
'WC_NO_BEST_FIT_CHARS
'WC_COMPOSITECHECK
'WC_DISCARDNS
'WC_SEPCHARS
'WC_DEFAULTCHAR
'
'lpWideCharStrUnicode '  
'cchWideChar ' Unicode   ,  -1 
''   NULL-terminated
''   
'lpMultiByteStr '     .
'
'cchMultiByte '   
'lpDefaultChar '      
'' Unicode     
''   .
'lpUsedDefaultChar ',     DefaultChar  .
'Return Value '    -   
'',    0.
'MultiByteToWideChar '    Unicode.
'
'CodePage .  WideCharToMultiByte dwFlags 
'  MB_PRECOMPOSED lpMultiByteStr 
'  cchMultiByte    , 
' NULL-terminated      
' -1. lpWideCharStr    Unicode
'. cchWideChar   Unicode  Return Value:
'   -   Unicode 
'   lpWideCharStr,    0.
'
':
'
' ConvertString   strStc    nFromCP,
'   nToCP,    .
'
'Public Function ConvertString(ByVal strSrc As String, _
'ByVal nFromCP As Long, _
'ByVal nToCP As Long) As String
'Dim nLen As Long
'Dim strDst As String
'Dim strRet As String
'Dim nRet As Long
'
'nLen = Len(strSrc)
'strDst = String(nLen * 2, Chr(0))
'strRet = String(nLen * 2, Chr(0))
'nRet = MultiByteToWideChar(nFromCP, MB_PRECOMPOSED, strSrc, nLen, strDst, nLen)
'nRet = WideCharToMultiByte(nToCP, 0, strDst, nRet, strRet, nLen * 2, ByVal 0, 0)
'ConvertString = Left(strRet, nRet)
'End Function
'
'
'  ! , , TextBox.     
'KOI,    Windows. :
'
'TextBox = StringConvert(TextBox, 20866, 1251)
'
' ! 400   !
'
'
''     
'
'Central European (DOS)852
'Central European Alphabet (Windows)1250
'Central European Alphabet (ISO)28592
'Cyrillic Alphabet (DOS)866
'Cyrillic Alphabet (Windows)1251
'Cyrillic Alphabet (ISO)28595
'Cyrillic Alphabet (KOI8-R)20866
'Ukrainian Alphabet (KOI8-RU)21866
'Latin 3 Alphabet (ISO)28593
'Western Alphabet1252
'Baltic Alphabet (Windows)1257
'Baltic Alphabet (ISO)28594
'Greek Alphabet (Windows)1253
'Greek Alphabet (ISO)28597
'Turkish Alphabet1254
'Arabic Alphabet (Windows)1256
'Arabic Alphabet (ISO)28596
'Hebrew (DOS)862
'Hebrew Alphabet (Windows)1255
'==========================================================================
'
'
'      .


